;; trr: a type-writing training program on GNU Emacs.
;;  Copyright (C) 1992 INAMURA, You
;;     Author:  INAMURA, You (inamura@icot.or.jp)

;;  Copyright (C) 1992 KATO Kenji (kato@ip.cs.oki.co.jp)
;;	Please send suggestions and corrections to the above address.

;; This software is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY.  No author or distributor
;; accepts responsibility to anyone for the consequences of using it
;; or for whether it serves any particular purpose or works at all,
;; unless he says so in writing.  Refer to the GNU Emacs General Public
;; License for full details.

;; Everyone is granted permission to copy, modify and redistribute
;; this software, but only under the conditions described in the
;; GNU Emacs General Public License.   A copy of this license is
;; supposed to have been given to you along with this software so you
;; can know your rights and responsibilities.  It should be in a
;; file named COPYING.  Among other things, the copyright notice
;; and this notice must be preserved on all copies.

(defvar TRR:directory (concat (getenv "TRRDIR") "/"))

(defconst TRR:history-of-trr "\
 0riginal(Pascal&C) -- $@<i;3(J $@9W(J\n\
 Emacs-Lisp version -- $@0pB<(J $@M:(J\n\
 Author -- $@2CF#8&;y(J, 1992/Nov/20\n\
 $@#t#r#r(J Nemacs$@8x3+HG(J Ver.1")

;; $@3F<o$N%U%!%$%k(J
(defconst TRR:update-program  (concat TRR:directory "update"))
(defconst TRR:message-file (concat TRR:directory "trr-message"))
(defconst TRR:select-text-file (concat TRR:directory "TEXT"))
(defvar   TRR:text-file nil "$@%F%-%9%H%U%!%$%k(J")
(defvar   TRR:record-file nil "$@<B9T7k2L$N%U%!%$%k(J")
(defvar   TRR:score-file nil "$@%9%3%"%U%!%$%k(J")

;; $@3F<o$N%P%C%U%!(J
(defconst TRR:trainer-menu-buffer     "$@%?%$%W!u%a%K%e!<(J")
(defconst TRR:result-buffer           "-----$@7k2L(J-----")
(defconst TRR:data-buffer             "$@@.@SI=<((J")
(defconst TRR:message-buffer          "$@%a%C%;!<%8(J")
(defconst TRR:log-buffer              "$@2a5n$N@.@S(J")
(defconst TRR:graph-buffer            "$@%0%i%U(J")
(defconst TRR:record-buffer           "$@$F$a$'$N<B9T5-O?$5(J")
(defconst TRR:display-buffer          "$@3F<oI=<((J")

;; $@3F<o$N%&%$%s%I%&%3%s%U%#%.%e%l!<%7%g%s(J
(defvar TRR:prev-win-conf    nil  "trr$@$r<B9T$9$kA0$N(Jwin-conf")
(defvar TRR:win-conf         nil  "trr$@$r<B9TCf$N(Jwin-conf")
(defvar TRR:win-conf-typist  nil  "$@%?%$%T%9%HMQ$N(Jwin-conf")
(defvar TRR:win-conf-display nil  "$@3F<oI=<(MQ$N(Jwin-conf")

;; $@3F<o$N%U%i%0(J
(defvar TRR:start-flag        nil "trr$@$,;O$^$C$F$$$k$+$I$&$+(J")
(defvar TRR:quit-flag         nil "trr$@$r=*N;$5$;$k$+$I$&$+(J")
(defvar TRR:update-flag       nil "$@5-O?99?7$7$?$+$I$&$+(J")
(defvar TRR:pass-flag         nil "$@%9%F%C%W$r%Q%9$7$?$+$I$&$+(J")
(defvar TRR:cheat-flag        nil "$@$$$s$A$-$7$?$+$I$&$+(J")
(defvar TRR:beginner-flag     nil "$@=i$a$F(Jtrr$@$r$7$?$+$I$&$+(J")
(defvar TRR:random-flag         t "trr$@$r$7$F$$$k$+$I$&$+(J")
(defvar TRR:secret-flag         t "update$@$7$J$$$+$I$&$+(J")
(defvar TRR:typist-flag         t "$@%?%$%T%9%H$rL\;X$9$+$I$&$+(J")
(defvar TRR:small-window-flag nil "$@%&%#%s%I%&$,>.$5$$$+$I$&$+(J")
(defvar TRR:skip-session-flag nil "$@%;%C%7%g%s$r<B9T$7$J$$$+$I$&$+(J")

;; $@%;%C%7%g%sKh$NJQ?t(J
(defvar TRR:eval               -1 "$@:#2s=P$7$?E@?t(J")
(defvar TRR:whole-char-count   0 "$@%F%-%9%H$NJ8;z?t(J")
(defvar TRR:correct-char-count 0 "$@@5$7$/F~NO$7$?J8;z?t(J")
(defvar TRR:start-time         0 "trr(1 session)$@$r=i$a$?;~4V(J")
(defvar TRR:end-time           0 "trr(1 session)$@$r=*$($?;~4V(J")
(defvar TRR:ch                 0 "trr$@<B9TCf$KFI$_9~$s$@%-%c%i%/%?(J")
(defvar TRR:miss-type-ratio    0 "$@%_%9N((J (/1000)")
(defvar TRR:type-speed         0 "$@%?%$%T%s%0B.EY!JJ8;z?t!?J,!K(J")

;; $@%9%F%C%WKh$NJQ?t(J
(defvar TRR:steps                       0 "$@8=:_L\;X$7$F$$$k%9%F%C%W(J")
(defvar TRR:times-of-current-step       0 "$@$3$N%9%F%C%W$G$N<B9T2s?t(J")
(defvar TRR:time-of-current-step        0 "$@$3$N%9%F%C%W$G$N<B9T;~4V(J")
(defvar TRR:whole-chars-of-current-step 0 "$@$3$N%9%F%C%W$G$N<B9T2s?t(J")
(defvar TRR:whole-miss-of-current-step  0 "$@$3$N%9%F%C%W$G$N<B9T;~4V(J")
(defvar TRR:times-for-message                  0 "trr-message.el$@$G;HMQ$9$k(J")

;; $@%0%i%U$r=q$/$?$a$NJQ?t(J
(defvar TRR:skipped-step         0 "$@%9%-%C%W$7$?%9%F%C%W?t(J")
(defvar TRR:list-of-eval       nil "$@K\F|$NF@E@%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-speed      nil "$@J?6QB.EY%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-miss       nil "$@J?6Q%_%9N(%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-average    nil "$@J?6QF@E@%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-time       nil "$@<B9T;~4V%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-times      nil "$@<B9T2s?t%0%i%UMQ$NJQ?t(J")
(defvar TRR:list-of-value      nil "$@FMGKE@?t%0%i%UMQ$NJQ?t(J")

;; $@$=$NB>$NJQ?t(J
(defvar TRR:number-of-text-lines 0 "$@%F%-%9%H$N9T?t(J - 18")
(defvar TRR:text-lines           0 "$@I=<($9$Y$-%F%-%9%H$N9T?t(J")
(defvar TRR:total-times          0 "$@:#$^$G$N<B9T2s?t(J")
(defvar TRR:total-time           0 "$@:#$^$G$N<B9T;~4V(J")
(defvar TRR:high-score           -1 "$@:#2s$^$G$N:G9bF@E@(J")
(defvar TRR:high-score-old       -1 "$@A02s$^$G$N:G9bF@E@(J")

;;; $@<+F0%m!<%I4X?t(J
(autoload 'picture-move-down "picture" "" nil)
(autoload 'TRR:print-first-message-as-result TRR:message-file "" nil)

;;; $@F@E@$NI>2A4X?t(J
;;; $@!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(J  $@0lHL$N?M(J
;;; $@!JBGJ8;z?t!]!J8mBG?t!v#5#0!K!K!v#6#0!?!JIC?t!K(J  $@%?%$%T%9%H$rL\;X$9?M(J
(defun TRR:evaluate-point (whole miss time)
  (if TRR:typist-flag
      (max 0 (if (= time 0) 0 (/ (* (- whole (* miss 50)) 60) time)))
    (max 0 (if (= time 0) 0 (/ (* (- whole (* miss 10)) 60) time)))))

(defun trr ()
  (interactive)
  (setq TRR:prev-win-conf (current-window-configuration))
  (setq TRR:skip-session-flag nil)
  (delete-other-windows)
  (if (or (< (window-height) 20) (< (window-width) 60))
      (message "$@%&%#%s%I%&$,>.$5$9$.$k$o!#(J")
    (TRR:start)
    (unwind-protect
      (while (TRR:play-p)
	(set-window-configuration TRR:win-conf)
	(if TRR:skip-session-flag
	    (progn
	      (setq TRR:start-flag t)
	      (setq TRR:skip-session-flag nil)
	      (set-window-configuration TRR:win-conf-display)
	      (set-buffer (get-buffer-create TRR:display-buffer))
	      (TRR:print-log-for-display))
	  (TRR:one-session)
	  (if (= TRR:ch 3)			
	      (setq TRR:quit-flag t)              ;  $@3d9~$_(J
	    (TRR:update-variables)
	    (TRR:display-variables-message-graph)
	    (if (and TRR:update-flag (not TRR:secret-flag))
		(TRR:update-score-file TRR:eval))
	    (widen)))))
    (TRR:finish)))


(defun TRR:play-p ()
  (and (not TRR:quit-flag)
       (if (not TRR:start-flag)
	   (progn (TRR:select-text)
		  (not TRR:quit-flag))
	 (TRR:select-menu)
	 (not TRR:quit-flag))))


(defun TRR:get-answer (string1 string2 max)
  (let ((answer (string-to-int (completing-read string1 ""))))
    (while (or (<= answer 0) (> answer max))
      (setq answer (string-to-int (completing-read string2 ""))))
    answer))


(defun TRR:select-text ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert-file TRR:select-text-file)
  (untabify (point-min) (point-max))
  (beginning-of-buffer)
  (let ((num 1) max-num)
    (while (not (eobp))
      (insert 
       (format "%4d. " num))
      (while (not (= (char-after (point)) 32)) (forward-char))
      (while      (= (char-after (point)) 32)  (forward-char))
      (while (not (= (char-after (point)) 32)) (forward-char))
      (kill-line)
      (forward-line 1)
      (setq num (1+ num)))
    (setq max-num num)
    (beginning-of-buffer)
    (insert (TRR:current-trr) "$@8~$1%?%$%W%H%l!<%J!<!'(J\n\n$@%F%-%9%H$NA*Br!'(J\n")
    (end-of-buffer)
    (insert "\n$@3F<o$N@_Dj!'(J\n  97. trr$@$N=*N;(J\n  98. $@@_DjCM$NJQ99(J\n")
    (if (not TRR:skip-session-flag)
	(insert "  99. $@%F%-%9%HA*Br8e%a%K%e!<2hLL$K0\9T(J\n")
      (insert "\n$@%F%-%9%HA*Br8e%a%K%e!<2hLL$K0\9T(J"))
    (setq num 
	 (progn
	   (TRR:get-answer "$@$I$l$K$9$k!)(J " "$@$O$C$-$j$7$J$5$$!*(J" 99)))
    (if (and (or (< num 0) (> num max-num))
	     (/= num 97)
	     (/= num 98)
	     (/= num 99))
	(setq num (TRR:get-answer "$@$b$&0lEYA*$s$G(J "
				  "$@%F%-%9%H$7$+A*$Y$J$$$o(J "
				  max-num)))
    (cond
     ((= num 97) (setq TRR:quit-flag t))
     ((= num 98) (TRR:change-flag))
     ((= num 99) 
      (setq TRR:skip-session-flag t)
      (TRR:select-text))
     (t
      (TRR:decide-trr-text num)
      (TRR:initiate-files)
      (TRR:initiate-variables)
      (TRR:print-log)
      (TRR:print-data)
      (bury-buffer)
      (set-window-configuration TRR:win-conf)))))


(defun TRR:change-flag ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (let (num)
    (insert "\
$@<!$NCf$+$iA*$s$G2<$5$$!#(J\n\
\n\
1. $@=i5i<T8~$1$N%?%$%W%H%l!<%J(J\n\
   $@I>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(J\n\
   $@%F%-%9%H$O%9%F%C%WKh$KF1$8$b$N$rI=<((J\n\
\n\
2. $@Cf5i<T8~$1$N%?%$%W%H%l!<%J!J%G%U%)!<%k%H$O$3$l$K@_Dj$5$l$k!K(J\n\
   $@I>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#1#0!K!K!v#6#0!?!JIC?t!K(J\n\
\n\
3. $@>e5i<T8~$1$N%?%$%W%H%l!<%J(J\n\
   $@I>2A4X?t$O!JBGJ8;z?t!]!J8mBG?t!v#5#0!K!K!v#6#0!?!JIC?t!K(J\n\
   $@#12s$N<B9T$GI,MW$J%?%$%WNL$,B?$$(J\n\
\n\
4. $@HkL)<g5A<T8~$1$N%?%$%W%H%l!<%J(J\n\
   $@=i5i<T8~$1$N%?%$%W%H%l!<%J$HF1$8$G$"$k$,!"(J\n\
   $@%O%$%9%3%"$NEPO?$r9T$J$o$J$$(J\n")
  (setq num (TRR:get-answer "$@$I$l$K$9$k!)(J " "$@$$$C$?$$$I$l$K$9$k$N!)(J " 4))
  (cond
   ((= num 1)
    (setq TRR:random-flag nil)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag nil))
   ((= num 2)
    (setq TRR:random-flag t)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag nil))
   ((= num 3)
    (setq TRR:random-flag t)
    (setq TRR:typist-flag t)
    (setq TRR:secret-flag nil))
   ((= num 4)
    (setq TRR:random-flag nil)
    (setq TRR:typist-flag nil)
    (setq TRR:secret-flag t))))
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (let* ((height (- (window-height) 5))
	 (text-buffer-height (1+ (- (/ height 2) (% (/ height 2) 3)))))
    (if TRR:typist-flag
	(setq TRR:text-lines (/ (1- (window-height)) 3))
      (setq TRR:text-lines (/ (1- text-buffer-height) 3))))
  (TRR:select-text))



(defun TRR:select-menu ()
  (set-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert "\
 1. $@=*N;(J               2. $@<B9T(J                3. $@%O%$%9%3%"(J\n\
 4. $@J?6QB.EY%0%i%U(J     5. $@J?6Q%_%9N(%0%i%U(J    6. $@J?6QF@E@%0%i%U(J\n\
 7. $@<B9T;~4V%0%i%U(J     8. $@<B9T2s?t%0%i%U(J      9. $@FMGKE@?t%0%i%U(J\n\
10. $@2a5n$N@.@S(J        11. $@%F%-%9%H$NJQ99(J     12. $@@_Dj$NJQ99(J\
")
  (let ((num (TRR:get-answer "$@$I$&$9$k$N!)(J " "$@$O$C$-$j$7$J$5$$!*(J" 12)))
    (cond
     ((= num 1) (setq TRR:quit-flag t) nil)
     ((= num 2) 
      (TRR:read-file TRR:text-file) ;  $@<!$N%F%-%9%H$rFI$`(J
      t)
     ((= num 3)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:show-ranking)
      (TRR:select-menu))
     ((= num 4)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-speed TRR:skipped-step
		       "$@%9%F%C%W!]J?6Q%9%T!<%I!JJ8;z!?J,!K%0%i%U(J")
      (TRR:select-menu))
     ((= num 5)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-miss TRR:skipped-step
		       "$@%9%F%C%W!]J?6Q%_%9N(!J(J/1000$@!K%0%i%U(J")
      (TRR:select-menu))
     ((= num 6)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-average TRR:skipped-step
		       "$@%9%F%C%W!]J?6QF@E@%0%i%U(J")
      (TRR:select-menu))
     ((= num 7)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-time TRR:skipped-step
		       "$@%9%F%C%W!]<B9T;~4V!JJ,!K%0%i%U(J")
      (TRR:select-menu))
     ((= num 8)
      (set-window-configuration TRR:win-conf-display)
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-times TRR:skipped-step
		       "$@%9%F%C%W!]<B9T2s?t%0%i%U(J")
      (TRR:select-menu))
     ((= num 9)
      (set-window-configuration TRR:win-conf-display)
      (set-buffer (get-buffer-create TRR:display-buffer))
      (TRR:get-graph-points)
      (TRR:write-graph TRR:list-of-value TRR:skipped-step
		       "$@%9%F%C%W!]FMGKE@?t%0%i%U(J")
      (TRR:select-menu))
     ((= num 10)
      (set-window-configuration TRR:win-conf-display)
      (set-buffer (get-buffer-create TRR:display-buffer))
      (TRR:print-log-for-display)
      (TRR:select-menu))
     ((= num 11)
      (TRR:save-file TRR:record-buffer TRR:record-file)
      (TRR:kill-file TRR:record-file)
      (TRR:kill-file TRR:score-file)
      (TRR:kill-file TRR:text-file)
      (TRR:kill-file TRR:record-file)
      (TRR:select-text)
      (not TRR:quit-flag))
     ((= num 12)
      (TRR:save-file TRR:record-buffer TRR:record-file)
      (TRR:kill-file TRR:record-file)
      (TRR:kill-file TRR:score-file)
      (TRR:kill-file TRR:text-file)
      (TRR:kill-file TRR:record-file)
      (TRR:change-flag)
      (not TRR:quit-flag))
)))


(defun TRR:initiate-files ()
  (save-excursion
    (find-file TRR:score-file)
    (find-file TRR:record-file)
    (find-file TRR:text-file)
    (if (not (file-exists-p TRR:score-file)) 
	(call-process "touch" nil 0 nil TRR:score-file)
      (call-process "chmod" nil 0 nil "666" TRR:score-file))
    (set-buffer (get-buffer-create TRR:record-buffer))
    (erase-buffer)
    (if (file-exists-p TRR:record-file)
	(insert-file TRR:record-file)
      (insert "  0    0      0      0     0 $@$U$!$$$H(J!\n"))))


(defun TRR:cheat-p ()
  (setq TRR:cheat-flag
	(or 
	 (if TRR:typist-flag
	     (< TRR:whole-char-count 480)
	   (< TRR:whole-char-count 160))
	 (and (> (- TRR:eval TRR:high-score) 100)
	      (not (< TRR:high-score 0))
	      (not (< TRR:total-times 3))
	      (not TRR:typist-flag))
	 (> TRR:eval 750))))


(defun TRR:decide-trr-text (num)
  (switch-to-buffer 
   (get-buffer-create TRR:trainer-menu-buffer))
  (erase-buffer)
  (insert-file TRR:select-text-file)
  (untabify (point-min) (point-max))
  (goto-line num)
  (while (not (= (char-after (point)) 32)) (forward-char))
  (while      (= (char-after (point)) 32)  (forward-char))
  (while (not (= (char-after (point)) 32)) (forward-char))
  (while      (= (char-after (point)) 32)  (forward-char))
  (let (temp temp-file temp-id)
    (setq temp (point))
    (while (not (= (char-after (point)) 32)) (forward-char))
    (setq temp-file (buffer-substring temp (point)))
    (while      (= (char-after (point)) 32)  (forward-char))
    (setq temp (point))
    (while (not (or (= (char-after (point)) 32)
		    (= (char-after (point)) 10))) (forward-char))
    (setq temp-id (buffer-substring temp (point)))
    (setq TRR:text-file (concat TRR:directory
				"text/"
				temp-file))
    (setq TRR:record-file (concat TRR:directory
				  "record/"
				  (user-login-name)
				  "-"
				  temp-id
				  (TRR:file-string)))
    (setq TRR:score-file (concat TRR:directory
				 "record/SCORES-"
				 temp-id
				 (TRR:file-string)))))

(defun TRR:file-string ()
  (cond
   (TRR:secret-flag "-easy")
   (TRR:typist-flag "-typist")
   ((not TRR:random-flag) "-easy")
   (t "")))


(defun TRR:prepare-buffers ()
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (split-window (get-buffer-window (current-buffer)) 5)
  (other-window 1)
  (switch-to-buffer (get-buffer-create TRR:display-buffer))
  (setq TRR:win-conf-display (current-window-configuration))
  (delete-other-windows)
  (switch-to-buffer (get-buffer-create TRR:trainer-menu-buffer))
  (setq TRR:win-conf-typist (current-window-configuration))
  (let* ((height (- (window-height) 5))
	 (text-buffer-height (1+ (- (/ height 2) (% (/ height 2) 3)))))
    (if TRR:typist-flag
	(setq TRR:text-lines (/ (1- (window-height)) 3))
      (setq TRR:text-lines (/ (1- text-buffer-height) 3))
      (if (< TRR:text-lines 3)
	  (progn
	    (setq TRR:small-window-flag t)
	    (setq TRR:text-lines (/ (1- (window-height)) 3)))
	(setq TRR:small-window-flag nil)))
    (set-buffer (get-buffer-create TRR:trainer-menu-buffer))
    (switch-to-buffer TRR:trainer-menu-buffer)
    (split-window (get-buffer-window (current-buffer))
		  text-buffer-height)
    (set-buffer (get-buffer-create TRR:result-buffer))
    (erase-buffer)
    (TRR:print-first-message-as-result)
    (switch-to-buffer-other-window TRR:result-buffer)
    (split-window (get-buffer-window (current-buffer)) 5)
    (split-window-horizontally 24)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:data-buffer))
    (TRR:print-data)
    (split-window-horizontally 20)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:message-buffer))
    (delete-region (point-min) (point-max))
    (insert TRR:history-of-trr)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:log-buffer))
    (split-window-horizontally 32)
    (TRR:print-log)
    (other-window 1)
    (switch-to-buffer (get-buffer-create TRR:graph-buffer))
    (TRR:write-graph TRR:list-of-eval 0 "$@:#F|$NF@E@%0%i%U(J")
    (recenter -1)
    (other-window 1)
    (setq TRR:win-conf (current-window-configuration))))


(defun TRR:start ()
  (message "$@$A$g$C$HBT$C$F(J...")
  (setq TRR:secret-flag nil)
  (setq TRR:random-flag t)
  (setq TRR:typist-flag nil)
  (setq TRR:start-flag nil)
  (setq TRR:quit-flag nil)
  (TRR:prepare-buffers)
  (picture-move-down 1)
  (picture-move-up 1))


(defun TRR:kill-buffer (buffer)
  (let ((tb (get-buffer buffer)))
    (if tb (kill-buffer tb))))

(defun TRR:kill-file (file)
  (if file
      (let ((tfile (get-file-buffer (expand-file-name file))))
	(if tfile (kill-buffer tfile)))))

(defun TRR:save-file (buffer file)
  (let ((tb (get-buffer buffer))
	tfile)
    (if tb
	(save-excursion
	  (set-buffer (get-buffer-create buffer))
	  (if (not (buffer-modified-p)) nil
	    (write-file file)
	    (setq tfile (concat file "~"))
	    (if (file-exists-p tfile) (delete-file tfile)))))))
      

(defun TRR:finish ()
  (TRR:kill-buffer TRR:trainer-menu-buffer)
  (TRR:kill-buffer TRR:result-buffer)
  (TRR:kill-buffer TRR:graph-buffer)
  (TRR:kill-buffer TRR:message-buffer)
  (TRR:kill-buffer TRR:data-buffer)
  (TRR:kill-buffer TRR:log-buffer)
  (TRR:kill-buffer TRR:display-buffer)
  (TRR:save-file TRR:record-buffer TRR:record-file)
  (TRR:kill-file TRR:record-file)
  (TRR:kill-file TRR:score-file)
  (TRR:kill-file TRR:text-file)
  (TRR:kill-buffer TRR:record-buffer)
  (TRR:kill-file TRR:record-file)
  (set-window-configuration TRR:prev-win-conf)
  (message "$@$^$?2q$&F|$^$G(J...."))


(defun TRR:one-session ()
  (other-window -1)
  (TRR:write-graph TRR:list-of-eval 0 "$@:#F|$NF@E@%0%i%U(J")
  (other-window -1)
  (TRR:print-log)
  (other-window 2)
  (if (or TRR:typist-flag TRR:small-window-flag)
      (set-window-configuration TRR:win-conf-typist))
  (erase-buffer)
  (save-excursion
    (set-buffer TRR:display-buffer)
    (if (not TRR:start-flag)
	(setq TRR:start-flag t))
    (copy-to-buffer TRR:trainer-menu-buffer
		    (point)
		    (progn
		      (forward-line (* 3 TRR:text-lines))
		      (point))))
  (goto-char (point-min))
  (forward-line 1)
  (setq TRR:correct-char-count 0)
  (setq TRR:whole-char-count 0)
  (if (eobp) t
    (let ((inhibit-quit 't)
	  (echo-keystrokes 0)
	  (lines (/ (count-lines (point-min) (point-max)) 3))
	  (text-pos (save-excursion (forward-line -1) (point)))
	  (started nil))
      (setq TRR:ch (read-char))
      (setq TRR:start-time (current-time-string))
      (while (and (> lines 0)
		  (/= TRR:ch 3))   ;; if TRR:ch = ^C then quit
	(setq TRR:whole-char-count (1+ TRR:whole-char-count))
	(if (= TRR:ch (char-after text-pos))
	    (progn
	      (setq TRR:correct-char-count (+ TRR:correct-char-count 1))
	      (setq text-pos (1+ text-pos))
	      (if (/= TRR:ch 13)
		  (progn
		    (insert-char TRR:ch 1)
		    (setq TRR:ch (read-char)))
		(insert-char 13 1)         ; cr mark
		(setq lines (1- lines))
		(if (/= lines 0)
		    (progn (forward-line 3)
			   (setq text-pos (save-excursion
					    (forward-line -1) (point)))
			   (setq TRR:ch (read-char))))))
	  (if (= TRR:ch 10)
	      (insert " ")
	    (if (= TRR:ch 12)
		(redraw-display)
	      (if (= TRR:ch 7)
		  (setq quit-flag 'nil)))
	    (insert-char TRR:ch 1))
	  (backward-char 1)
	  (while (and (/= TRR:ch (char-after text-pos))
		      (/= TRR:ch  3))
	    (setq TRR:ch (read-char))
	    (delete-char 1)
	    (if (= TRR:ch 10)
		(insert " ")
	      (if (= TRR:ch 12)
		  (redraw-display)
		(if (= TRR:ch 7)
		    (setq quit-flag 'nil)))
	      (insert-char TRR:ch 1))
	    (backward-char 1))
	  (picture-move-down 1)
	  (insert "^")
	  (forward-line -1)
	  (end-of-line)
	  (backward-delete-char 1)
	  (setq text-pos (1+ text-pos))
	  (if (/= TRR:ch 13)
	      (if (= TRR:ch 3)
		  (setq lines 0)
		(insert-char TRR:ch 1)        ; blink or reverse mode
		(setq TRR:ch (read-char)))
	    (setq lines (1- lines))
	    (insert-char 13 1)             ; cr mark
	    (if (/= lines 0)
		(progn (forward-line 3)
		       (setq text-pos (save-excursion
					(forward-line -1) (point)))
		       (setq TRR:ch (read-char)))))))
      ;; dummy 
      (setq TRR:end-time (current-time-string))
      (recenter -2)))
  (if (or TRR:typist-flag TRR:small-window-flag)
      (set-window-configuration TRR:win-conf)))


(defun TRR:update-variables ()
  (setq TRR:quit-flag nil)
  (let ((started-from (TRR:convert-time-string-to-second TRR:start-time))
	(ended-at (TRR:convert-time-string-to-second TRR:end-time)))
    (setq TRR:elapsed-time (- ended-at started-from))
    (if (< ended-at started-from)
	(setq TRR:elapsed-time (+ elapsed 86400))))
  (setq TRR:eval 
	(TRR:evaluate-point TRR:whole-char-count
			    (- TRR:whole-char-count TRR:correct-char-count)
			    TRR:elapsed-time))
  (setq TRR:list-of-eval (cons TRR:eval TRR:list-of-eval))
  (setq TRR:pass-flag
	(and (>= TRR:eval (* 10 (1+ TRR:steps)))
	     (not (TRR:cheat-p))))
  (setq TRR:update-flag
	(and (or (> TRR:eval TRR:high-score)
		 (< TRR:high-score-old 0))
	     (not (TRR:cheat-p))))
  (setq TRR:beginner-flag (< TRR:high-score-old 0))
  (if TRR:cheat-flag nil
    (setq TRR:total-time (+ TRR:total-time TRR:elapsed-time))
    (setq TRR:total-times (1+ TRR:total-times))
    (setq TRR:time-of-current-step 
	  (+ TRR:time-of-current-step TRR:elapsed-time))
    (setq TRR:times-of-current-step (1+ TRR:times-of-current-step))
    (setq TRR:whole-chars-of-current-step
	  (+ TRR:whole-char-count TRR:whole-chars-of-current-step))
    (setq TRR:whole-miss-of-current-step
	  (+ (- TRR:whole-char-count TRR:correct-char-count)
	     TRR:whole-miss-of-current-step)))
  (TRR:write-current-data)
  (if TRR:pass-flag
      (progn 
	(setq TRR:times-for-message TRR:times-of-current-step)
	(setq TRR:time-of-current-step 0)
	(setq TRR:times-of-current-step 0)
	(setq TRR:whole-chars-of-current-step 0)
	(setq TRR:whole-miss-of-current-step 0)
	(if TRR:beginner-flag
	    (setq TRR:steps (/ TRR:eval 10))
	  (setq TRR:steps (1+ TRR:steps)))))
  (if TRR:update-flag
      (progn
	(setq TRR:high-score-old TRR:high-score)
	(setq TRR:high-score TRR:eval)))
  (if (< TRR:high-score-old 0) (setq TRR:high-score-old TRR:eval))
  (let (diff)
    (setq diff (- TRR:whole-char-count TRR:correct-char-count))
    (setq TRR:miss-type-ratio (/ (* 1000 diff) TRR:whole-char-count)))
  (setq TRR:type-speed (/ (* TRR:whole-char-count 60) TRR:elapsed-time)))


(defun TRR:display-variables-message-graph ()
  (other-window 1)
  (TRR:print-result)
  (other-window 1)
  (TRR:print-data)
  (other-window 1)
  (TRR:print-message)
  (other-window 1)
  (TRR:print-log)
  (other-window 1)
  (TRR:write-graph TRR:list-of-eval 0 "$@:#F|$NF@E@%0%i%U(J")
  (other-window 1))


(defun TRR:print-result ()
  (erase-buffer)
  (insert
   (format "\
 $@=jMW;~4V!'(J%4d $@IC(J\n\
  $@%_%9N((J $@!'(J%2d.%1d %%\n\
 $@;z?t!?J,!'(J%4d\n\
  $@I>(J  $@2A(J $@!'(J%4d %s"
	   TRR:elapsed-time
	   (/ TRR:miss-type-ratio 10)
	   (% TRR:miss-type-ratio 10)
	   TRR:type-speed
	   TRR:eval
	   (if TRR:pass-flag " Pass" "Retry"))))


(defun TRR:print-data ()
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:data-buffer))
    (erase-buffer)
    (insert 
     (format "\
 $@%9%F%C%W!'(J%5d\n\
  $@L\(J  $@I8(J $@!'(J%5d$@E@(J\n\
 $@:G9b5-O?!'(J%5d$@E@(J\n\
  trr$@2s?t!'(J%5d$@2s(J"
	     (1+ TRR:steps) 
	     (* (1+ TRR:steps) 10)
	     (if (< TRR:high-score 0) 0 TRR:high-score)
	     TRR:total-times))))
  

(defun TRR:print-log ()
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:log-buffer))
    (erase-buffer)
    (let (curstep  curtimes curtime curpoint curmiss curspeed wc mc curdate)
      (switch-to-buffer (get-buffer-create TRR:record-buffer))
      (goto-char (point-min))
      (setq curstep 1)
      (while (not (eobp))
	(setq curpoint (point))
	(setq curtimes (string-to-int 
			   (buffer-substring
			    (+ curpoint 4) (+ curpoint  8))))
	(setq curtime (string-to-int 
			  (buffer-substring 
			   (+ curpoint 9) (+ curpoint 15))))
	(setq wc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 16) (+ curpoint 22))))
	(setq mc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 23) (+ curpoint 28))))
	(setq curmiss 
	      (if (= wc 0) 0 (/ (* mc 1000) wc)))
	(setq curspeed 
	      (if (= curtime 0) 0 (/ (* wc 60) curtime)))
	(setq curdate (buffer-substring 
			   (+ curpoint 29) (+ curpoint 38)))
	(forward-line)
	(switch-to-buffer (get-buffer-create TRR:log-buffer))
	(if (not (= wc 0))
	    (insert (format "%2d:%4d%4d%5d%4d %s\n" 
			    curstep
			    curtimes
			    (/ curtime 60)
			    curspeed
			    curmiss
			    curdate)))
	(setq curstep (+ curstep 1))
	(switch-to-buffer (get-buffer-create TRR:record-buffer))))
      (switch-to-buffer (get-buffer-create TRR:log-buffer))
      (previous-line (- (window-height) 3))
      (delete-region (point-min) (point))
      (insert (TRR:current-trr) "$@8~$1%?%$%W%H%l!<%J(J\n")
      (insert "step $@2s(J  $@J,(J   $@B.(J  $@N((J   $@FMGKF|(J\n")))


(defun TRR:print-log-for-display ()
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:display-buffer))
    (erase-buffer)
    (let (curstep curtimes curtime curpoint passpoint
		  avepoint curmiss curspeed wc mc curdate)
      (switch-to-buffer (get-buffer-create TRR:record-buffer))
      (goto-char (point-min))
      (setq curstep 1)
      (while (not (eobp))
	(setq curpoint (point))
	(setq passpoint (string-to-int 
			   (buffer-substring
			    curpoint (+ curpoint 3))))
	(setq curtimes (string-to-int 
			   (buffer-substring
			    (+ curpoint 4) (+ curpoint  8))))
	(setq curtime (string-to-int 
			  (buffer-substring 
			   (+ curpoint 9) (+ curpoint 15))))
	(setq wc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 16) (+ curpoint 22))))
	(setq mc (string-to-int 
			  (buffer-substring 
			   (+ curpoint 23) (+ curpoint 28))))
	(setq curmiss 
	      (if (= wc 0) 0 (/ (* mc 1000) wc)))
	(setq curspeed 
	      (if (= curtime 0) 0 (/ (* wc 60) curtime)))
	(setq avepoint (if (= curtime 0) 0 
			 (TRR:evaluate-point wc mc curtime)))
	(setq curdate (buffer-substring 
			   (+ curpoint 29) (+ curpoint 38)))
	(forward-line)
	(switch-to-buffer (get-buffer-create TRR:display-buffer))
	(if (not (= wc 0))
	    (insert (format "\
 %2d:  %3d$@2s(J  %3d$@J,(J  %4d$@;z(J/$@J,(J  %3d.%d%%  %4d$@E@(J   %s   %d\n" 
			    curstep
			    curtimes
			    (/ curtime 60)
			    curspeed
			    (/ curmiss 10)
			    (% curmiss 10)
			    avepoint
			    curdate
			    passpoint)))
	(setq curstep (+ curstep 1))
	(switch-to-buffer (get-buffer-create TRR:record-buffer))))
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (previous-line (- (window-height) 6))
      (delete-region (point-min) (point))
      (insert 
       (format "\
$@:G9b5-O?!'(J%d$@E@(J,   $@Am<B9T2s?t!'(J%d$@2s(J,   $@Am<B9T;~4V!'(J%d$@J,(J\n"
	       (if (< TRR:high-score 0) 0 TRR:high-score)
	       TRR:total-times
	       (/ TRR:total-time 60)))
      (insert "\n\
step   $@<B9T(J   $@<B9T(J     $@J?6Q(J     $@J?6Q(J     $@J?6Q(J     $@FMGKF|(J   $@FMGK(J\n\
       $@2s?t(J   $@;~4V(J   $@F~NOB.EY(J  $@%_%9N((J    $@F@E@(J              $@F@E@(J\n\
---------------------------------------------------------------\n")))


(defun TRR:current-trr ()
  (cond
   (TRR:typist-flag "$@>e5i<T(J")
   (TRR:secret-flag "$@HkL)<g5A<T(J")
   (TRR:random-flag "$@Cf5i<T(J")
   (t               "$@=i5i<T(J")))

(defun TRR:write-current-data ()
  (save-excursion
    (set-buffer (get-buffer-create TRR:record-buffer))
    (if TRR:beginner-flag
	(let ((count (1- (/ TRR:eval 10))))
	  (while (> count 0)
	    (insert "  0    0      0      0     0 $@$U$!$$$H(J!\n")
	    (setq count (1- count)))))
    (goto-char (point-max))
    (previous-line 1)
    (beginning-of-line)
    (delete-region (point) (point-max))
    (insert (format "%3d %4d %6d %6d %5d %s\n"
		    TRR:eval
		    TRR:times-of-current-step
		    TRR:time-of-current-step
		    TRR:whole-chars-of-current-step
		    TRR:whole-miss-of-current-step
		    (TRR:get-date)))
    (if TRR:pass-flag
	(insert "  0    0      0      0     0 $@$U$!$$$H(J!\n"))))


(defun TRR:convert-time-string-to-second (st)
  (let ((hr (string-to-int (substring st 11 13))) ; $@2?;~!)(J
	(min (string-to-int (substring st 14 16))) ; $@2?J,!)(J
	(sec (string-to-int (substring st 17 19)))) ; $@2?IC!)(J
    (+ sec (* 60 (+ min (* 60 hr))))))

  
(defun TRR:read-file (filename)
  (save-excursion
    (set-buffer (get-file-buffer (expand-file-name TRR:text-file)))
    (if TRR:random-flag
	(goto-line (TRR:random-num))
      (goto-line
	 (* TRR:steps (/ TRR:number-of-text-lines 64))))
    (let (fill-column text start)
      (while (not (or (= (char-after (point)) 33)
		      (= (char-after (point)) 46)
		      (= (char-after (point)) 63))) (forward-char))
      (forward-char)
      (while (or 
	      (= (char-after (point)) 10)
	      (= (char-after (point)) 32)
	      (= (char-after (point)) 34))
	(forward-char))
      (setq start (point))
      (forward-line 18)
      (setq text (buffer-substring start (point)))
      (switch-to-buffer (get-buffer-create TRR:display-buffer))
      (setq fill-column (- (window-width) 4))
      (erase-buffer)
      (insert text)
      (fill-region (point-min) (point-max))
      (goto-char (point-min))
      (while (not (eobp))
	(end-of-line)
	(insert "
\n\n")
	(forward-line 1))
      (goto-char (point-min)))))


(defun TRR:initiate-variables ()
  (setq TRR:total-times 0)
  (setq TRR:total-time  0)
  (setq TRR:times-of-current-step 0)
  (setq TRR:time-of-current-step  0)
  (setq TRR:whole-chars-of-current-step 0)
  (setq TRR:whole-miss-of-current-step 0)
  (set-buffer (get-file-buffer (expand-file-name TRR:text-file)))
  (setq TRR:number-of-text-lines (- (count-lines (point-min) (point-max)) 18))
  (set-buffer (get-buffer-create TRR:display-buffer))
  (erase-buffer)
  (TRR:read-file TRR:text-file)
  (setq TRR:high-score (TRR:get-hich-score))
  (setq TRR:high-score-old TRR:high-score)
  (setq TRR:beginner-flag (< TRR:high-score-old 0))
  (set-buffer (get-buffer-create TRR:record-buffer))
  (setq TRR:steps (1- (count-lines (point-min) (point-max))))
  (goto-char (point-min))
  (while (not (eobp))
    (setq TRR:times-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 4) (+ (point) 8))))
    (setq TRR:total-times
	  (+ TRR:total-times TRR:times-of-current-step))
    (setq TRR:time-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 9) (+ (point) 15))))
    (setq TRR:total-time
	  (+ TRR:total-time TRR:time-of-current-step))
    (setq TRR:whole-chars-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 16) (+ (point) 22))))
    (setq TRR:whole-miss-of-current-step
	     (string-to-int
	      (buffer-substring (+ (point) 23) (+ (point) 28))))
    (forward-line))
)


(defun TRR:write-graph (data-list skip string)
  (erase-buffer)
  (insert string "\n")
  (let ((fill-column (window-width)))
    (center-region (point-min) (point)))
  (let ((max 0)
	(min 10000)
	(rest data-list)
	(revlist nil)
	(steps 0)
	(move-count 0)
	temp graph-steps horizontal-steps scale-x scale-y)
    (if (not rest) t
      (setq steps (1+ steps))
      (setq temp (car rest))
      (setq rest (cdr rest))
      (setq max (max max temp))
      (if (= temp 0) t
	(setq min (min min temp)))
      (setq revlist (cons temp revlist)))
    (while rest
      (setq steps (1+ steps))
      (setq temp (car rest))
      (setq rest (cdr rest))
      (setq max (max max temp))
      (setq min (min min temp))
      (setq revlist (cons temp revlist)))
    (setq graph-steps (/ (- (window-height) 5) 2)       ; $@=DL\@9$j$N?t!)(J
	  horizontal-steps (/ (- (window-width) 8) 4)   ; $@2#L\@9$j$N?t!)(J
	  scale-x (let ((i horizontal-steps))
		    (while (< i steps)
		      (setq i (* i 2)))
		    (/ i horizontal-steps))
	  fill-column (- (window-width) 4))
    (let ((diff (- steps (* horizontal-steps 2))))
      (if (> diff 0)
	  (progn 
	    (while (> diff 0)
	      (setq revlist (cdr revlist))
	      (setq move-count (1+ move-count))
	      (setq diff (1- diff)))
	    (setq steps (* horizontal-steps 2))
	    (setq scale-x 2)
	    (setq rest revlist)
	    (setq max 0)
	    (setq min 10000)
	    (while rest
	      (setq max (max max (car rest)))
	      (if (or (cdr rest) (not (= 0 (car rest))))
		  (setq min (min min (car rest))))
	      (setq rest (cdr rest))))))
    (if (> min max) (setq min 0)
      (setq min (- min (% min 10))))
    (setq scale-y (max 1 
		       (if (= (% (- max min) graph-steps) 0)
			   (/ (- max min) graph-steps)
			 (1+ (/ (- max min) graph-steps)))))
;; 1 2 3 4 5 6 8 10 12 15 20 25 30 40 50 60 70 80 90 100 120 140 160 180 200..
    (cond ((> scale-y 100)                                 ;; 20 $@$G$^$k$a$k(J
	   (if (= (% scale-y 20) 0)
	       (setq scale-y (* (/ scale-y 20) 20))
	     (setq scale-y (+ (* (/ scale-y 20) 20) 20))))
	  ((> scale-y 30)                                  ;; 10 $@$G$^$k$a$k(J
	   (if (= (% scale-y 10) 0)
	       (setq scale-y (* (/ scale-y 10) 10))
	     (setq scale-y (+ (* (/ scale-y 10) 10) 10))))
	  ((> scale-y 13)                                  ;;  5 $@$G$^$k$a$k(J
	   (if (= (% scale-y 5) 0)
	       (setq scale-y (* (/ scale-y 5) 5))
	     (setq scale-y (+ (* (/ scale-y 5) 5) 5))))
	  ((> scale-y 6)                                   ;;  2 $@$G$^$k$a$k(J
	   (if (= (% scale-y 2) 0)
	       (setq scale-y (* (/ scale-y 2) 2))
	     (setq scale-y (+ (* (/ scale-y 2) 2) 2)))))
    (if (< graph-steps 2)
	t
      (let ((i graph-steps))
	(while (> i 0)
	  (insert "     $@(-(J\n" (format "%4d" (+ min (* i scale-y)))
		  " $@(2(J\n")
	  (setq i (1- i)))
	(insert "     $@(-(J\n" (format "%4d" min) " $@(1(J")
	(while (< i horizontal-steps)
	  (insert "$@(,(5(J")
	  (setq i (1+ i)))
	(insert (format "\n   %4d" move-count))
	(setq i 1)
	(while (<= i horizontal-steps)
	  (insert (format "%4d" (+ 
				 (* i scale-x)
				 skip
				 move-count)))
	  (setq i (1+ i))))
      (goto-char (point-max))
      (beginning-of-line)
      (forward-char 5)
      (let ((times (max 1 (/ 4 scale-x)))
	    (inter (max 1 (/ scale-x 4)))
	    (templist revlist)
	    (i 1)
	    data height)
	(save-excursion
	  (while templist
	    (setq data (car templist))
	    (setq templist (cdr templist))
	      (let ((th (/ (* (- data min) 4) scale-y)))
		(setq height (+ (/ th 2) (% th 2))))
	      (forward-char times)
	      (save-excursion
		(picture-move-up (1+ height))
		(if (and (= i 1) (= times 1))
		    (progn
		      (delete-char 1)
		      (insert " ")))
		(if (= height 0)
		    (if (or (not (= data 0)) templist)
			(progn (delete-char 2)
			       (insert "$@!z(J")))
		  (insert "$@!z(J")))
	      (setq i (1+ i))))))))


(defun TRR:random-num ()
  (let (num
	(num1 (random))
	(num2 (random t)))
    (if (> num1 0) t
      (setq num1 (- num1)))
    (if (> num2 0) t
      (setq num2 (- num2)))
    (setq num (+ (/ num1 2) (/ num2 2)))
    (% num TRR:number-of-text-lines)))


(defun TRR:update-score-file (score)
  (call-process TRR:update-program nil 0 nil
		TRR:directory
		"TanakaMaririnGanbarimasu"
		TRR:score-file
		(user-login-name)
		(int-to-string score) 
		(int-to-string TRR:steps)
		(int-to-string TRR:total-times)
		(int-to-string (/ TRR:total-time 60))))


(defun TRR:get-hich-score ()
  (set-buffer (get-file-buffer (expand-file-name TRR:score-file)))
  (goto-char (point-min))
  (while (and 
	  (not (eobp))
	  (not (looking-at (format "%s\t" (user-login-name)))))
    (forward-line 1))
  (if (eobp)
      -1
    (let (beg)
      (while (not (looking-at "\t"))
	(forward-char 1))
      (while (looking-at "\t")
	(forward-char 1))
      (setq beg (point))
      (while (not (looking-at "\t"))
	(forward-char 1))
      (string-to-int (buffer-substring beg (point))))))


(defun TRR:show-ranking ()
  (set-buffer (get-buffer-create TRR:display-buffer))
  (erase-buffer)
  (insert "\
$@=g0L(J\t$@%m%0%$%sL>(J\t$@%9%3%"(J\tstep\t$@Am2s?t(J\t$@Am;~4V(J\t  $@F|IU(J,   $@;~4V(J\n")
  (insert-file TRR:score-file)
  (goto-char (point-min))
  (forward-line 1)
  (let ((i 1)
	(self nil))
    (while (not (eobp))
      (insert (format "%d\t" i))
      (if (looking-at (format "%s\t" (user-login-name)))
	  (progn
	    (beginning-of-line)
	    (while (not (looking-at "\t")) (forward-char 1))
	    (forward-char 1)
	    (insert ">>> ")
	    (while (not (looking-at "\t")) (forward-char 1))
	    (insert " <<<")
	    (forward-char 1)
	    (if (looking-at "\t") (delete-char 1))
	    (setq self (match-beginning 1))))
      (forward-line 1)
      (setq i (1+ i)))
    (if self
	(goto-char self)
      (goto-char (point-min))))
  (switch-to-buffer TRR:display-buffer))


(defun TRR:get-graph-points ()
  (setq TRR:skipped-step 0)
  (setq TRR:list-of-speed nil)
  (setq TRR:list-of-miss nil)
  (setq TRR:list-of-time nil)
  (setq TRR:list-of-times nil)
  (setq TRR:list-of-value nil)
  (setq TRR:list-of-average nil)
  (save-excursion
    (switch-to-buffer (get-buffer-create TRR:record-buffer))
    (goto-char (point-min))
    (let ((curstep 1)
	  (curpoint (point))
	  curtime wc mc)
      (while (not (eobp))
	(setq wc (string-to-int 
		  (buffer-substring 
		   (+ curpoint 16) (+ curpoint 22))))
	(setq mc (string-to-int 
		  (buffer-substring 
		   (+ curpoint 23) (+ curpoint 28))))
	(setq curtime (string-to-int 
		       (buffer-substring 
			(+ curpoint 9) (+ curpoint 15))))
	(if (= curtime 0)
	    (setq TRR:skipped-step (1+ TRR:skipped-step))
	  (setq TRR:list-of-value
		(cons 
		 (string-to-int
		  (buffer-substring 
		   curpoint (+ curpoint 3)))
		 TRR:list-of-value))
	  (setq TRR:list-of-times
		(cons 
		 (string-to-int
		  (buffer-substring 
		   (+ curpoint 4) (+ curpoint 8)))
		 TRR:list-of-times))
	  (setq TRR:list-of-time
		(cons 
		 (/ curtime 60)
		 TRR:list-of-time))
	  (setq TRR:list-of-speed
		(cons 
		 (if (= curtime 0) 0 (/ (* wc 60) curtime))
		 TRR:list-of-speed))
	  (setq TRR:list-of-miss
		(cons 
		 (if (= wc 0) 0 (/ (* mc 1000) wc))
		 TRR:list-of-miss))
	  (setq TRR:list-of-average
		(cons 
		 (TRR:evaluate-point wc mc curtime)
		 TRR:list-of-average)))
 	(forward-line)
	(setq curpoint (point))
	(setq curstep (+ curstep 1))))))


(defun TRR:get-date ()
  (if (not TRR:pass-flag) "$@$U$!$$$H(J!"
    (let ((in-string (current-time-string))
	  (out-string nil))
      (setq out-string (concat out-string (substring in-string 22 24)))
      (setq out-string (concat out-string "/"))
      (setq out-string (concat out-string (substring in-string 4 7)))
      (setq out-string (concat out-string "/"))
      (setq out-string (concat out-string (substring in-string 8 10))))))
